/* 
 * File:   oc_config.h
 * Author: cstgeo
 *
 * Created on April 7, 2018, 2:59 PM
 */

#ifndef OC_CONFIG_H
#define	OC_CONFIG_H
#include "config.h"


#define SERVO_TRIM 0
#define SERVO_PERIOD 50000
#define SERVO_INITIAL_DUTY 7.6
#define SERVO_CLOCK_DIVIDER 2

void config_fmd_a_oc() {
    OC1CON =	0x0000;
    OC1RS =		(unsigned)(SERVO_PERIOD*SERVO_INITIAL_DUTY/100);
    OC1R =		SERVO_PERIOD-OC1RS;
		OC1CON =	0x0006;
		
		OC1CONSET = 0x8000;
}

void config_fmd_b_oc() {
    OC2CON =	0x0000;
    OC2RS =		(unsigned)(SERVO_PERIOD*SERVO_INITIAL_DUTY/100);
    OC2R =		SERVO_PERIOD-OC2RS;
		OC2CON =	0x0006;
		
		OC2CONSET = 0x8000;
}

void config_rmd_a_oc() {
    OC3CON =	0x0000;
    OC3RS =		(unsigned)(SERVO_PERIOD*SERVO_INITIAL_DUTY/100);
    OC3R =		SERVO_PERIOD-OC3RS;
		OC3CON =	0x0006;
		
		OC3CONSET = 0x8000;
}

void config_rmd_b_oc() {
    OC4CON =	0x0000;
    OC4RS =		(unsigned)(SERVO_PERIOD*SERVO_INITIAL_DUTY/100);
    OC4R =		SERVO_PERIOD-OC4RS;
		OC4CON =	0x0006;
		
		OC4CONSET = 0x8000;
}


void config_servo_oc() {
		OC5CON =	0x0000;
		PWM_Timer_Prescale_Select = SERVO_CLOCK_DIVIDER;
		PR2 =			SERVO_PERIOD-1;
    OC5RS =		(unsigned)(SERVO_PERIOD*SERVO_INITIAL_DUTY/100);
    OC5R =		SERVO_PERIOD-OC5RS;
		OC5CON =	0x0006;
		
		T2CONSET = 0x8000;
		OC5CONSET = 0x8000;
}

void configure_oc() {
 printConfigurationStarted(OC);
// config_fmd_a_oc();
// config_fmd_b_oc();
// config_rmd_a_oc();
// config_rmd_b_oc();
 config_servo_oc();
 printConfigurationCompleted(OC);
}

#endif	/* OC_CONFIG_H */

