/* 
 * File:   servo_config.h
 * Author: cstgeo
 *
 * Created on April 14, 2018, 5:35 PM
 */

#ifndef SERVO_CONFIG_H
#  define	SERVO_CONFIG_H
#include "config.h"

void configure_servo() {
	AD1PCFG = 0xFFFF; //Set all to digital
  AD1PCFGbits.PCFG4 = 0b0; //B4 set back to analog
  AD1CHSbits.CH0NA  = 0b0; //Selecting input
  AD1CON1bits.FORM  = 0b000; //Format
  AD1CON1bits.SSRC  = 0b000; //Sampling
  AD1CON2bits.VCFG  = 0b111; //Voltage Reference
  AD1CON2bits.BUFM  = 0b0; //16 bit buffer, single
  AD1CON2bits.ALTS  = 0b0; //Only use MUX A

  AD1CON3bits.ADRC =   0b0; //Makes it use the prescaler
  AD1CON3bits.ADCS =   PR2/2/FPB-1; //Setting the prescaler
  AD1CON1bits.ON =     1; //Turning it on
}

void Servo() {
	if(AD1CON1bits.DONE && !AD1CON1bits.SAMP) {
    __XC_UART = __PC_UART;
    printf("\r\t\t\t\t\t\t AN4: %d            ", ADC1BUF0);
    AD1CHSbits.CH0SA = 4;
    AD1CON1bits.SAMP = 1;
    T3CONbits.TON = 1;
	}
}

void extendPV() {
	
}

void retractPV() {
	
}

void lockPV() {
	
}

void unlockPV() {
	
}

#endif	/* SERVO_CONFIG_H */

