/* 
 * File:   interrupt_config_Timer_RoverMeasure.h
 * Author: cstgeo
 *
 * Created on February 11, 2018, 2:52 PM
 */

#define	INTERRUPT_CONFIG_TIMER_INITIALIZATION_H
#include "config.h"

// RoverMeasure Timer (Timer 3)
#define RoverMeasure_Timer_Interrupt_Flag Timer_4_Interrupt_Flag
#define RoverMeasure_Timer_Interrupt_Priority Timer_4_Interrupt_Priority
#define RoverMeasure_Timer_Interrupt_Subpriority Timer_4_Interrupt_Subpriority
#define RoverMeasure_Timer_Interrupt_Enable Timer_4_Interrupt_Enable



//Timer_Interrupt(object, timer_number, priority, subpriority, event_type, is_enabled)
Interrupt(RoverMeasure_Timer,TIMER_4,6,1,Overflow,enabled) {
    sym * gam_data = read_gam();
		gam_data_struct gam = convert_gam_data(gam_data);
    if (gam.accel.z_g < 0) {
        orientation = true;
    }
    else if (gam.accel.z_g > 0) {
        orientation = false;
    }
		read_lidar();
		sym * ldr_data = read_lidar();
		ldr_data_struct ldr = convert_ldr_data(ldr_data);
    print.ldr(ldr_data);
    if (ldr.distance_cm < 20){
        stopRover();
        T4CONbits.TON = 0;
    }
    else if (ldr.distance_cm < 150) {
        turnLeft();
    }
    else {
        driveForward();
    }
 RoverMeasure_Timer_Interrupt_Flag = false; // clear flag
}


