/* 
 * File:   timer_config_Initialization.h
 * Author: cstgeo
 *
 * Created on April 15, 2018, 1:07 PM
 */

#ifndef TIMER_CONFIG_INITIALIZATION_H
#  define	TIMER_CONFIG_INITIALIZATION_H
#include "config.h"

// Initialization Timer (Timer 3)
#define Initialization_Timer_On Timer_3_On
#define Initialization_Timer_Gated Timer_3_Gated
#define Initialization_Timer_Prescale_Select Timer_3_Prescale_Select
#define Initialization_Timer_Prescale_256 Timer_3_Prescale_256
#define Initialization_Timer_Count Timer_3_Count
#define Initialization_Timer_Period Timer_3_Period

#define Initialization_Period 10000

void configure_initialization_timer() {
    printf("\r\n\t\t" "void configure_initialization_timer()");
    Initialization_Timer_Prescale_256;
    Initialization_Timer_Count = 0;
    Initialization_Timer_Period = Initialization_Period;
		E.LORA_nRESET = low;
    Initialization_Timer_On = true;
}

#endif	/* TIMER_CONFIG_INITIALIZATION_H */

