/* 
 * File:   timer_config_PWM.h
 * Author: cstgeo
 *
 * Created on April 15, 2018, 1:07 PM
 */

#ifndef TIMER_CONFIG_PWM_H
#  define	TIMER_CONFIG_PWM_H
#include "config.h"

// PWM Timer (Timer 2)
#define PWM_Timer_On Timer_2_On
#define PWM_Timer_Gated Timer_2_Gated
#define PWM_Timer_Prescale_Select Timer_2_Prescale_Select
#define PWM_Timer_Prescale_1	 Timer_2_Prescale_1	
#define PWM_Timer_Prescale_2	 Timer_2_Prescale_2	
#define PWM_Timer_Prescale_4	 Timer_2_Prescale_4	
#define PWM_Timer_Prescale_8	 Timer_2_Prescale_8	
#define PWM_Timer_Prescale_16 Timer_2_Prescale_16	
#define PWM_Timer_Prescale_32 Timer_2_Prescale_32	
#define PWM_Timer_Prescale_64 Timer_2_Prescale_64	
#define PWM_Timer_Prescale_256 Timer_2_Prescale_256

#define PWM_Timer_Count Timer_2_Count
#define PWM_Timer_Period Timer_2_Period

#define PWM_Period 1000/*24975*/

void configure_PWM_timer() {
    printf("\r\n\t\t" "void configure_PWM_timer()");
		PWM_Timer_Prescale_Select = 7;
    PWM_Timer_Count = 0;
    PWM_Timer_Period = PWM_Period;
    PWM_Timer_On = false;
		
		
//		D.MD_MODE = 0;
//		MOTOR_SET(FMD,A,0,99,0);
}

#endif	/* TIMER_CONFIG_PWM_H */

